
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java进阶:JNI使用技巧点滴_Java编程 / iVAN</title>

    <meta name="description" content="Java进阶:JNI使用技巧点滴_Java编程 文章来源:csdn 作者:normalnotebook 摘要 本文为在 32 位 Windows 平台上实现 Java 本地方法提供了实用的示例.步骤和准则.本文中的示例使用 Sun Microsystems 公司创建的 Java Development Kit (JDK) 版本 1.4.1.用 C 语言编写的本地代码是用 Microsoft Visual C++ 编译器编译生成. 简介 近日,由于项目需要,要在WEB页面实现图像转换功能,而VC在图像转换方面有着得天独厚的优势.我们首先用VC封">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java进阶:JNI使用技巧点滴_Java编程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>文章来源：csdn 作者：normalnotebook<br />
        <br /><strong>　摘要</strong></p>
<p>　　 本文为在 32 位 Windows 平台上实现 Java 本地方法提供了实用的示例、步骤和准则。本文中的示例使用 Sun Microsystems 公司创建的 Java Development Kit (JDK) 版本 1.4.1。用 C 语言编写的本地代码是用 Microsoft Visual C++ 编译器编译生成。</p>
<p>　　<strong>简介</strong></p>
<p>　　近日，由于项目需要，要在WEB页面实现图像转换功能，而VC在图像转换方面有着得天独厚的优势。我们首先用VC封装出图像转换的DLL，然后用JAVA的本地化方法JNI调用用于图像转换的DLL，最后用JavaBean调用JNI生成的DLL。</p>
<p>　　通过近几天在网上找资料和自己的摸索，收获很多，现总结如下，让以后做这方面的人少走弯路。</p>
<p>　　<strong>一. JAVA部分</strong></p>
<p><strong>　　1. 无包的情况：</strong></p>
<p><strong>　　实例一：</strong></p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　public class MyNative</p>
<p>　　{</p>
<p>　　static</p>
<p>　　{</p>
<p>　　System.loadLibrary( "MyNative" );           </p>
<p>　　}</p>
<p>　　public native static void HelloWord();</p>
<p>　　public native static String cToJava();</p>
<p>　　}</p>
</td>
</tr>
</tbody>
</table>
<p>　　<strong>说明：</strong></p>
<p>　　1)在JAVA程序中，首先需要在类中声明所调用的库名称System.loadLibrary( String libname );，在库的搜寻路径中定位这个库。定位库的具体操作依赖于操作系统。在windows下，首先从当前目录查找，然后再搜寻”PATH”环境变量列出的目录。如果找不到该库，则会抛出UnsatisfiedLinkError。</p>
<p>　　2)这里加载的是JNI生成的DLL，而不是其他生成的DLL的名称。 在这里，库的扩展名字可以不用写出来，究竟是DLL还是SO，由系统自己判断。</p>
<p>　3) 还需要对将要调用的方法做本地声明，关键字为native。并且只需要声明，而不需要具体实现。 实现放在C中实现，稍后将做说明。</p>
<p>　　4)如果加了static，表明是静态方法。如果不加，表明是一般的方法。加与不加，生成的头文件中有一个参数不同。稍后将做说明。</p>
<p>　<strong>　现在开始编译它:</strong></p>
<p>　　用javac MyNative.h编译它，生成对应的class文件。</p>
<p>　　用javah MyNative ，就会生成对应的MyNative.h头文件。剩下的是就开始交给VC来完成了（我们用VC来实现对应的C实现部分）。</p>
<p>　<strong>　2. 有包的情况：</strong></p>
<p><strong>　　实例二：</strong></p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　package  com..myNative;</p>
<p>　　public class MyNative</p>
<p>　　{</p>
<p>　　static</p>
<p>　　{</p>
<p>　　System.loadLibrary( "MyNative" );           </p>
<p>　　}</p>
<p>　　public native static void HelloWord();</p>
<p>　　public native static String cToJava();</p>
<p>　　}</p>
</td>
</tr>
</tbody>
</table>
<p>　　其他与上面相同，就是在用javac和javah时有所不同。对于有包的情况一定要注意这一点，开始时我的程序始终运行都不成功，问题就出在这里。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　javac  ./com/myNative/MyNative.java</p>
<p>　　javah  com.myNative.MyNative</p>
</td>
</tr>
</tbody>
</table>
<p>　　上面一句就不用解释了。对下面的一句解释一下：本类的前面均是包名。这样生成的头文件就是：com.myNative.MyNative.h。 开始时，在这种情况下我用javah MyNative生成的头文件始终是MyNative.h。在网上查资料时，看见别人的头文件名砸那长，我的那短。但不知道为什么，现在大家和我一样知道为什么了吧。：）。有时还需要带上路径。具体查看javah的语法。</p>
<p>　<strong>二．C实现部分</strong></p>
<p>　　刚才用javah MyNative生成的MyNative.h头文件内容如下：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　/* DO NOT EDIT THIS FILE - it is machine generated */</p>
<p>　　#include &lt;jni.h&gt;</p>
<p>　　/* Header for class MyNative */</p>
<p>　　#ifndef _Included_MyNative</p>
<p>　　#define _Included_MyNative</p>
<p>　　#ifdef __cplusplus</p>
<p>　　extern "C" {</p>
<p>　　#endif</p>
<p>　　/*</p>
<p>　　* Class:     MyNative</p>
<p>　　* Method:    HelloWord</p>
<p>　　* Signature: ()V</p>
<p>　　*/</p>
<p>　　JNIEXPORT void JNICALL Java_MyNative_HelloWord (JNIEnv *, jclass);</p>
<p>　　/*</p>
<p>　　* Class:     MyNative</p>
<p>　　* Method:    cToJava</p>
<p>　　* Signature: ()Ljava/lang/String;</p>
<p>　　*/</p>
<p>　　JNIEXPORT jstring JNICALL Java_MyNative_cToJava  (JNIEnv *, jclass);</p>
<p>　　#ifdef __cplusplus</p>
<p>　　}</p>
<p>　　#endif</p>
<p>　　#endif</p>
</td>
</tr>
</tbody>
</table>
<p>　接下来,就是如何实现它了。其实，用JNI作出的东西也是DLL，被JAVA所调用。</p>
<p>　　在具体实现的时候，我们只关心两个函数原型：</p>
<table>
<tbody>
<tr>
<td></td>
<td>　　JNIEXPORT void JNICALL Java_MyNative_HelloWord(JNIEnv *, jclass);和JNIEXPORT jstring JNICALL Java_MyNative_cToJava(JNIEnv *, jclass);</td>
</tr>
</tbody>
</table>
<p>　　现在让我们开始激动人心的第一步吧 : ) 。在project里面选择win32 Dynamic-link Library，然后点击下一步，其余的取默认。如果不取默认的，将会有dllmain()函数。取空DLL工程的话，将无这个函数。我在这里取的是空。</p>
<p>　　然后选择new-&gt;File-&gt;C++ Source  File，生成一个空*.cpp文件。我们把他取名为MyNative。把JNIEXPORT void JNICALL Java_MyNative_HelloWord(JNIEnv *, jclass);和JNIEXPORT jstring JNICALL Java_MyNative_cToJava(JNIEnv *, jclass);拷贝到CPP文件中去。然后把头文件包含进来。</p>
<p>　<strong>　生成的MyNative.cpp内容如下：</strong></p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　#include &lt;stdio.h&gt;</p>
<p>　　#include "MyNative.h"</p>
<p>　　JNIEXPORT void JNICALL Java_MyNative_HelloWord  (JNIEnv *env, jclass jobject)</p>
<p>　　{</p>
<p>　　printf("hello word!\n");        </p>
<p>　　}<br />
                      　　 JNIEXPORT jstring JNICALL Java_MyNative_cToJavaJNIEnv *env, jclass obj)</p>
<p>　　{</p>
<p>　　jstring jstr;</p>
<p>　　char str[]="Hello,word!\n";</p>
<p>　　jstr=env-&gt;NewStringUTF(str);</p>
<p>　　return jstr;</p>
<p>　　}</p>
</td>
</tr>
</tbody>
</table>
<p>　　在编译前一定要注意下列情况。</p>
<p>　　注意：一定要把SDK中的include文件夹中(和它下面的win32文件夹下的头文件)的几个头文件拷贝到VC的include文件夹中。或者在VC的tools\options\directories中设置，把头文件给包含进来。</p>
<p>　<strong>对程序的一点解释：</strong></p>
<p>　　1)前文不是说过，加了static和不加只是一个参数的区别吗。就是jclass的不同，不加static这里就是jobject。也就是JNIEXPORT void JNICALL Java_MyNative_HelloWord(JNIEnv *env, jobject obj)。</p>
<p>　　2)这里JNIEXPORT和JNICALL都是JNI的关键字，表示此函数是要被JNI调用的。而jstring是以JNI为中介使JAVA的String类型与本地的string沟通的一种类型，我们可以视而不见，就当做String使用(具体对应见表一)。函数的名称是JAVA_再加上java程序的package路径再加函数名组成的（参见有包的情况）。参数中，我们也只需要关心在JAVA程序中存在的参数，至于JNIEnv*和jclass我们一般没有必要去碰它。</p>
<p>　　3)NewStringUTF()是JNI函数，从一个包含UTF格式编码字符的char类型数组中创建一个新的jstring对象。</p>
<p>　　4) 以上程序片断jstr=env-&gt;NewStringUTF(str);是C++中的写法，不必使用env指针。因为JNIEnv函数的C++版本包含有直接插入成员函数，他们负责查找函数指针。而对于C的写法，应改为：jstr=(*env)-&gt;NewStringUTF(env,str);因为所有JNI函数的调用都使用env指针，它是任意一个本地方法的第一个参数。env指针是指向一个函数指针表的指针。因此在每个JNI函数访问前加前缀(*env)-&gt;，以确保间接引用函数指针。</p>
<p>　　在C和Java编程语言之间传送值时，需要理解这些值类型在这两种语言间的对应关系。这些都在头文件jni.h中，用typedef语句声明了这些类在目标平台上的代价类。头文件也定义了常量如：JNI_FALSE=0 和JNI_TRUE=1;表一说明了Java类型和C类型之间的对应关系。</p>
<p>　　<strong>表一   Java类型和C类型</strong>　</p>
<table>
<tbody>
<tr>
<td>Java编程语言</p>
</td>
<td>C编程语言</p>
</td>
<td>字节</p>
</td>
</tr>
<tr>
<td>boolean</p>
</td>
<td>jboolean</p>
</td>
<td>1</p>
</td>
</tr>
<tr>
<td>byte</p>
</td>
<td>jbyte</p>
</td>
<td>1</p>
</td>
</tr>
<tr>
<td>char</p>
</td>
<td>jchar</p>
</td>
<td>2</p>
</td>
</tr>
<tr>
<td>short</p>
</td>
<td>jshort</p>
</td>
<td>2</p>
</td>
</tr>
<tr>
<td>int</p>
</td>
<td>jint</p>
</td>
<td>4</p>
</td>
</tr>
<tr>
<td>long</p>
</td>
<td>jlong</p>
</td>
<td>8</p>
</td>
</tr>
<tr>
<td>float</p>
</td>
<td>jfloat</p>
</td>
<td>4</p>
</td>
</tr>
<tr>
<td>double</p>
</td>
<td>jdouble</p>
</td>
<td>8</p>
</td>
</tr>
</tbody>
</table>
<p>　　 现在开始对所写的程序进行编译。选择build-&gt;rebuild all对所写的程序进行编译。点击build-&gt;build MyNative.DLL生成DLL文件。<br />
        <br />　　<br />
        也可以用命令行cl来编译。具体参看其他书籍。<br />
        <br />　　再次强调（曾经为这个东西大伤脑筋）：DLL放置地方</p>
<p>　　1) 当前目录。</p>
<p>　　2) 放在path所指的路径中</p>
<p>　　3) 自己在path环境变量中设置一个路径，要注意所指引的路径应该到.dll文件的上一级，如果指到.dll，则会报错。</p>
<p>　下面就开始测试我们的所写的DLL吧（假设DLL已放置正确）。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　public class mytest</p>
<p>　　{</p>
<p>　　public static void main(String[] args)</p>
<p>　　{</p>
<p>　　MyNative a=new MyNative();</p>
<p>　　a.HelloWord();</p>
<p>　　System.out.println(a.cToJava());</p>
<p>　　}</p>
<p>　　}</p>
</td>
</tr>
</tbody>
</table>
<p>　　注意也要把MyNative.class放在与mytest.java同一个路径下。现在开始编译运行mytest，是不是在DOS窗口上输出：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　Hello word!</p>
<p>　　Hello,world!</p>
</td>
</tr>
</tbody>
</table>
<p>　　以上是我们通过JNI方法调用的一个简单C程序。但在实际情况中要比这复杂的多。特别是在通过JNI调用其他DLL时，还有很多的地方需要注意。</p>
<p>　　现在开始来讨论包含包的情况，步骤与上面的相同，只是有一点点不同。我们来看其中的一个函数。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　JNIEXPORT void JNICALL Java_com_MyNative_MyNative_HelloWord (JNIEnv *env, jclass jobject)</p>
<p>　　{</p>
<p>　　printf("hello word!\n");        </p>
<p>　　}</p>
</td>
</tr>
</tbody>
</table>
<p>　　我们来观察函数名称。函数的名称是JAVA_再加上java程序的package路径再加函数名组成的。现在这句话应该理解了吧。</p>
<p>　　我们也写一个程序来测试包含包的情况。程序略。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<br />　　javac ./com/MyNative/mytest.java</p>
<p>　　java mytest</p>
</td>
</tr>
</tbody>
</table>
<p>　　是不是在DOS窗口上也显示同样的内容：）。</p>
<p>　　这次，就到这里吧，下一讲将讲述JNI调用其他DLL时应该注意的地方，同时会给出一个具体的例子。也将会给出一个UNICODE编码和ASCII编码之间互相转换的通用函数。如果有什么疑问可以与我交流：normalnotebook@126.com</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-08 17:06:23</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java进阶:JNI使用技巧点滴_Java编程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkY8Zz.html" rel="bookmark">Java运行时多态性的实现&lowbar;Java编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				InterA  a; a= new B(); a.fun();         a = new C();  a.fun();         } } 输出结果为: This is B This is C 上例中类B和类C是实现接口InterA的两个类,分别实现了接口的方法fun(),通过将类B和类C的实例赋给接口引用a而实现了方法在运行时的动态绑定,充分利用了&quot;一个接口,多个方法&quot;展示了Java的动态多态性. 需要注意的一点是:Java在利用接口变量调用其实现类的对象的方法时,该方法必			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXK2ZLM.html" rel="bookmark">跟我学Java Swing之游戏设计&lpar;1&rpar;&lowbar;Java编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章来源:电脑爱好者 作者:张剑 谁知道通天的巴比伦塔耗费了多少沙石?又有谁知道罗马的建成经历了多少个日夜?我们惟一知道的是,没有一块块砖石的垒砌,就没有蜿蜒万里的长城;没有巨石和黏土的堆集,就没有亘古不变的金字塔.由此可见,基础知识的准备对于我们学习任何事物都至关重要,那么,就让我们从认识Swing的一些基础功能开始,启动我们建造罗马的伟大工程吧! 前言 Java咖啡馆已经开张不少时日了,如果你已经喜欢上了Java这杯咖啡的味道,那么记得常来哦.这一次,我们为大家准备了一大杯香浓的咖啡--将以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlJJqp.html" rel="bookmark">跟我学Java Swing之游戏设计&lpar;2&rpar;&lowbar;Java编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章来源:电脑爱好者 作者:张剑 还记得&lt;偷天换日&gt;中精灵般穿梭在好莱坞车流中的Minicooper吗?马克·沃尔伯格和莎莉·赛隆就是驾驶着它在仇人的鼻子底下运走了价值千万的黄金.可是,如果现在将一辆无法奔驰的Minicooper躯壳放在你的面前,你会如何看待它?它还是那个游走自如的精灵吗?今天,就让我们一点一点地为这辆Minicooper组装上零件,让它跑起来. 前言 从本期开始,我们为大家提供完整的游戏源代码(点击下载).Java咖啡馆倡导大家理论与实践并重,我们在连载中将给大家介绍关键技			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqD0R3b.html" rel="bookmark">Java性能优化技巧汇总&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例汇总了Java性能优化技巧.分享给大家供大家参考.具体分析如下: 这里参考了些书籍,网络资源整理出来,适合于大多数Java应用 在JAVA程序中,性能问题的大部分原因并不在于JAVA语言,而是程序本身.养成良好的编码习惯非常重要,能够显著地提升程序性能. 1.尽量使用final修饰符. 带有final修饰符的类是不可派生的.在JAVA核心API中,有许多应用final的例子,例如java.lang.String.为String类指定final防止了使用者覆盖length()方法.另外,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bol1vVM.html" rel="bookmark">Java进阶教程之异常处理&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序很难做到完美,不免有各种各样的异常.比如程序本身有bug,比如程序打印时打印机没有纸了,比如内存不足.为了解决这些异常,我们需要知道异常发生的原因.对于一些常见的异常,我们还可以提供一定的应对预案.C语言中的异常处理是简单的通过函数返回值来实现的,但返回值代表的含义往往是由惯例决定的.程序员需要查询大量的资料,才可能找到一个模糊的原因.面向对象语言,比如C++, Java, Python往往有更加复杂的异常处理机制.这里讨论Java中的异常处理机制. Java异常处理 异常处理 Java的异			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL5gZAz.html" rel="bookmark">Java中一些关键字的使用技巧总结&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				final-- final用于类表示该类不能派生子类. final用于方法表示该方法不能被子类重写. final用于变量时表示常量,类似于C/C++的const关键字. final用于成员变量表示该成员变量为常量,不能被修改,必须在变量定义时赋值. final用于局部变量表示该局部变量为常量,不能被修改,可以在变量定义时赋值,也可以先定义变量后赋值. static-- static用于成员变量表示该变量只有一份,也就是说静态成员变量属于类而不属于某个具体的类实例对象,所有的类实例对象共享这个静态			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkP59M.html" rel="bookmark">JAVA中JNI的简单使用分享&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				了解JNI:JAVA因其跨平台特性而受人们喜爱,也正因此,使得它和本机各种内部联系变得很少,所以JNI(Java Native Interface)就是用来解决JAVA本地操作的一种方式.JAVA通过JNI调用本地方法,而本地方法是以库文件的形式存放的(在WINDOWS平台上是DLL文件形式,在UNIX机器上是SO文件形式).通过调用本地的库文件的内部方法,使JAVA可以实现和本地机器的紧密联系,调用系统级的各接口方法. 步骤如下: 1.写好.java源文件: 复制代码 代码如下: packag			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo39w3b.html" rel="bookmark">Java咖啡馆&lpar;1&rpar;&mdash;&mdash;叹咖啡&lowbar;Java编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章来源:电脑爱好者 作者:Gary Chan 有人说,咖啡馆是一个叫人学会放慢步伐.享受生活的地方.这句话不无道理.港人常把饮咖啡称为&quot;叹咖啡&quot;,这个&quot;叹&quot;字就有欣赏.品味的含义,舒适的环境,自然是招徕顾客之道.香港虽然寸金尺土,但无论在闹市或是在风景区,都不难找到精巧雅致的咖啡馆,它们或具欧陆情怀,或富英式韵味,大都环境优美.摆设得体.席位舒适.气派不凡. 一.序言 许多人想学习编程,但不知道从哪里开始.在这个连载中,我将为你介绍Java编程技术,以及Java程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWG4LGM.html" rel="bookmark">Java的JNI快速入门教程&lpar;推荐&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. JNI简介 JNI是Java Native Interface的英文缩写,意为Java本地接口. 问题来源:由于Java编写底层的应用较难实现,在一些实时性要求非常高的部分Java较难胜任(实时性要求高的地方目前还未涉及,实时性这类话题有待考究). 解决办法:Java使用JNI可以调用现有的本地库(C/C++开发任何和系统相关的程序和类库),极大地灵活Java的开发. 2. JNI快速学习教程 2.1 问题: 使用JNI写一段代码,实现string_Java_Test_helloworld			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXYKz5.html" rel="bookmark" class="title">分布式数据库&mdash;&mdash;从线性扩展谈分布式JOIN</a>
					<div>
						在首届阿里巴巴中间件峰会上,来自阿里巴巴DRDS团队的梦实分享了&lt;分布式数据库--从线性扩展谈分布式JOIN&gt;.他主要从OLTP数据库的线性扩展.水平扩容.IN查询.分布式JOIN四个方面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQvYoM.html" rel="bookmark" class="title">ASP内置对象详解精彩教程</a>
					<div>
						对象|教程|内置对象|详解 使用ASP开发动态网站我们经常使用到其中的六个内置的对象,今天给大家收集了一下供大家参考! 1.ASP内置对象详解之Session对象 [2005-03-16]     2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0a3Pp.html" rel="bookmark" class="title">改变表的一列的缺省值</a>
					<div>
						sql server : ALTER TABLE dbo.Test ADD CONSTRAINT DF_Test_column2 DEFAULT 'a' FOR column2 oracle: ALT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6a8Ob.html" rel="bookmark" class="title">以一个最简单的例子把OO的JavaScript说明白</a>
					<div>
						javascript  OO的JavaScript并不高深,麻烦就麻烦在google出来的国人介绍文章经常罗罗嗦嗦,而且之间的说法还各有不同,摆在一起就让人看了头大.这里重拾简单主义,以一个最简单的例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R26op.html" rel="bookmark" class="title">使用jqMobi开发app基础之Scrolling的使用，拖动后大量空白的解决</a>
					<div>
						在使用jqMobi开发app基础:Scrolling的使用,向上向下拖动,动态添加数据一文中,通过使用af.scroller.js解决了上拉刷新,下拉添加数据的功能,可是很奇怪,经过多次下拉后,发下底 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwl5lnb.html" rel="bookmark" class="title">专业商务之典范 联想ThinkPad T60笔记本电脑</a>
					<div>
						ThinkPad T系列笔记本电脑作为商务市场的主流机型,一直以超乎寻常的稳定性.安全性和良好的使用舒适度而闻名遐迩.T60为目前ThinkPad T系列机型的旗舰产品,新款的T60还搭载了最新的Me ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOw4Lqz.html" rel="bookmark" class="title">Rails Caching详解</a>
					<div>
						问题出现: I am trying to use caches_action and the agile book says that it is keyed off the URL, however ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKP01p.html" rel="bookmark" class="title">PS把图片素材转成火焰效果</a>
					<div>
						教程制作非常有创意.制作思路:先定义好自己喜欢的火焰样式,然后把图层清空.再把自己喜欢的素材定义成笔刷,在之前定义好样式的图层上刷上笔刷即可. 原图   最终效果   1.新建文档500 * 650  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY76oM.html" rel="bookmark" class="title">TT浏览器如何设hao123为首页</a>
					<div>
						或按照如下方式操作: 1.打开TT浏览器,选择工具 - TT选项,如图所示: 2.选择启动和退出,输入http://www.hao123.com/ 为主页,勾选启动时打开主页.最后别忘了点击保存按钮. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNw8WM.html" rel="bookmark" class="title">查看Win8隐藏文件夹的三种方法</a>
					<div>
						  方法一:进入win8系统计算机面板,然后在计算机面板上,随意打开一个文件夹,然后点击菜单栏上的&quot;查看&quot;. 方法二:在Win8系统资源管理器窗口上,直接按住Alt键弹出工具栏.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZXXvz.html" rel="bookmark" class="title">数组、指针、C标准&hellip;&hellip;</a>
					<div>
						说起指针,初学C语言的时候,总是让人感觉似懂非懂. 后来,学习到了很多操作系统.计算机组成原理.体系结构的知识,逐渐深切地认识到:指针其实就是一块一个字长大小的内存单元,它上面保存着 被其指向的 另一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYREJZp.html" rel="bookmark" class="title">Javascript Validation for email&lpar;正则表达式&rpar; 英文翻译&lowbar;正则表达式</a>
					<div>
						Try testing the following form with valid and invalid email addresses. The code uses javascript to m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE674AM.html" rel="bookmark" class="title">Dwr3&period;0纯注解&lpar;纯Java Code配置&rpar;配置与应用浅析三之后端反向调用前端&lowbar;java</a>
					<div>
						在前两篇中我们已经介绍了Dwr零配置文化化和前端调用后端的方法,想必大家应该已经会熟练掌握了,下来我们主要探讨一下后端怎么反向调用前端的js方法: 就如前两篇说到了用Dwr注册了两个Service组件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My34okz.html" rel="bookmark" class="title">js实现tab选项卡函数代码&lowbar;javascript技巧</a>
					<div>
						one1 one2 one3 one4 cont_one_1 cont_one_2 cont_one_3 cont_one_4 tow1 tow2 tow3 cont_tow_1 cont_tow_2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE46qPz.html" rel="bookmark" class="title">Jedis对redis的操作详解</a>
					<div>
						通过前一篇&lt;redis的简单使用&gt;的简单介绍,本篇主要阐述Jedis对redis的五大类型的操作:字符串.列表.散列.集合.有序集合. JedisUtil 这里的测试用例采用junit4进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeR0Q8b.html" rel="bookmark" class="title">ofbiz服务引擎到底有什么好处</a>
					<div>
						问题描述 ofbiz服务引擎到底有什么好处 ofbiz服务引擎到底有什么好处 在controler里用 type=&quot;java&quot; 和type=&quot;service&quot;各 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeXjrb.html" rel="bookmark" class="title">看斯诺登直播是种怎样的体验？明日凌晨一点亲眼见证，预告！</a>
					<div>
						       据美国科技播客 Recode 12月12日报道,Twitter 的 CEO 杰克·多西将于美国当地时间周二上午(即北京时间12月14日凌晨1点)对美国国家安全局的前承包商雇员.大名鼎鼎的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRrkwb.html" rel="bookmark" class="title">河南开始整治网络秩序 涉黄博客将会被关闭</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 昨日,记者从省公安厅获悉, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNy4qM.html" rel="bookmark" class="title">酒店综合布线设计方案</a>
					<div>
						当今社会,信息已成为一种非常关键性的资源,它必须精确.迅速地传输于各种通讯设备.数据处理设备和显示设备之间.由于这一原因,公司.企业.政府部门都会要求以最快速度对这些通讯及信息系统进行调整和改进,并根 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqdXDp.html" rel="bookmark" class="title">数据库-hibernate每次查询都要打印好多东西才开始查询，差不多都要2 - 3秒</a>
					<div>
						问题描述 hibernate每次查询都要打印好多东西才开始查询,差不多都要2 - 3秒 [img=http://forum.csdn.net/PointForum/ui/scripts/csdn/Pl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEVJ3M.html" rel="bookmark" class="title">卸载了sql&comma;重新安装sql后，一直连接超时</a>
					<div>
						问题描述 卸载了sql,重新安装sql后,一直连接超时 今天一时冲动卸载了SQL,在重新安装的过程中,改了端口为3307,把选择服务器类型改为Developer Machine. 然后在运行一个卸载S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLZZYM.html" rel="bookmark" class="title">AWS F1 正式上线，深度解析 FPGA 与公有云的亲密接触</a>
					<div>
						1. 背景 历经近 5 个月的邀请内测,Amazon AWS 于 4 月 20 日宣布 FPGA EC2 实例 F1 正式上线.就在 F1 内测公布后这短短几个月时间,国内互联网巨头 BAT 加华为纷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK56Anp.html" rel="bookmark" class="title">上线一月破千万，孙俪都是其粉丝，揭秘花粉儿APP的成长秘诀</a>
					<div>
						作为母婴闲置交易APP花粉儿的创始人,郑晓文在8月收到了一份不错的成绩单:才上线一个月,花粉儿就拿下了同类APP下载量第一.月交易额过千万的惊人成绩,还吸引了孙俪.董璇.黄奕.邬君梅.甘薇.国际名模吕 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPW8aZM.html" rel="bookmark" class="title">布局车联网 哪些无线技术将更受关注？</a>
					<div>
						作为物联网(IoT)的具体应用以及表现之一,车联网是以车为节点和信息源,通过无线通信等技术手段获取车本身以及车外部等属性,并加以有效利用,从而达到&quot;人-车-路-环境&quot;和谐统一的新体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2YREoz.html" rel="bookmark" class="title">iOS 环信2&period;0 发送消息重复。</a>
					<div>
						问题描述 我自定义消息扩展,在其他控制器上调用ChatViewController的sendMessage方法,回话记录会出现两条信息,一条没有时间,一条有时间,重新进入聊天界面只有一条消息 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNmO6Wb.html" rel="bookmark" class="title">uva  10099   The Tourist Guide</a>
					<div>
						点击打开链接uva 10099 题目意思: 有一个旅游团现在去出游玩,现在有n个城市,m条路.由于每一条路上面规定了最多能够通过的人数,现在想问这个旅游团人数已知的情况下最少需要运送几趟 思路:最大生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByRwAz.html" rel="bookmark" class="title">mysql分表问题（insert&lowbar;method的理解）</a>
					<div>
						问题描述 mysql分表问题(insert_method的理解) CREATE TABLE account_all (id int(11) NOT NULL AUTO_INCREMENT name v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YLv0p.html" rel="bookmark" class="title">《C语言程序设计：问题与求解方法》&mdash;&mdash;2&period;14节表达式</a>
					<div>
						2.14 表达式所谓表达式是用一个或多个运算符将运算量连接起来的.可计算出一个明确数值的式子.运算量包括常量.变量.函数调用和子表达式.在表达式中,还可以使用圆括号来改变运算符固有的先后运算顺序.此时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdejQM.html" rel="bookmark" class="title">【宣传易】抗战英雄纯弹广告暂停投放</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 通知!由于56.html&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnOYorz.html" rel="bookmark" class="title">WINDOW&period;OPEN ＰＤＦ文件</a>
					<div>
						问题描述 public void reportPrint() throws Exception{ String root_path = ServletActionContext.getServletC ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
